var gParentURL;
var gFound = false;
var gNumSections;

function getSafariSections()
{
	//get browser window DOM
        var focusedWindow = document.commandDispatcher.focusedWindow;
	var domDocument = focusedWindow.document;

	getURLFromDocumentAndCountSections( domDocument );
	
	if( gFound )
	{
		var otherStr;
		var munge = 0;
		var strURL = gParentURL;
		var location = strURL.indexOf( "SECT", 0 );
		//check that we found the URL like we want it...
		if( location != -1 )
		{
			otherStr = strURL.substring( 0, location );
			otherStr = otherStr + "SECT-";
			munge = 6;
		}
		else
		{
			location = strURL.indexOf( "lev1sec", 0 );
			otherStr = strURL.substring( 0, location );
			otherStr = otherStr + "lev1sec";
			munge = 8;
		}
		
		if( gNumSections > 20 )
		{
			alert( "Trouble getting the sections!" );
			return;
		}
		
		for( i = 1; i < gNumSections + 1; i++ )
		{
			totalURL = otherStr + i + strURL.substring(location + munge, strURL.length );
			var digIt =  "http://safari.oreilly.com/" + totalURL;
			openURLInTab( digIt );
		}
	}

}

function getURLFromDocumentAndCountSections( doc )
{
	gFound = false;
	gNumSections = 0;
	//get element with "img src=images/btn_next_gif"
	var imgNodes = doc.getElementsByTagName( 'img' );
	for( i = 0; i < imgNodes.length; i++ )
	{
		if( imgNodes[i].getAttribute( "src" ) == "images/btn_next.gif" )
		{
			//get parent of that element and get its href attribute
			gParentURL = imgNodes[i].parentNode.getAttribute( 'href' );
			gFound = true;
		}
		if( imgNodes[i].getAttribute( "src" ) == "images/left_note.gif" )
		{
			if( imgNodes[i].parentNode.previousSibling != null )
			{
				gNumSections++;
			}
		}
	}

	return;	
}

function openURLInTab( url )
{
	try {	
	var kWinMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	if( kWinMediator == null )
	{
		alert( "Didn't create windows mediator." );
		return;
	}
	else
	{
		var gBrowserWindow = kWinMediator.getMostRecentWindow( "navigator:browser" );
		if( gBrowserWindow != null )
		{
			var b = gBrowserWindow.getBrowser();
			if( b != null )
			{
				b.addTab(  url );
			}
		}
		else
		{
			alert( "Not created." );
			return;
		}
	}
	}
	catch( e )
	{
		alert( e );
		alert( e.message );
	}
}

